--- //depot/vendor/freebsd/src/sys/i386/i386/sys_machdep.c	2007/05/20 22:07:53
+++ //depot/user/attilio/attilio_schedlock/i386/i386/sys_machdep.c	2007/05/25 23:55:45
@@ -447,9 +447,11 @@
 
 	mdp->md_ldt = NULL;
 	if (refcount_release(&pldt->ldt_refcnt)) {
+		mtx_unlock_spin(&dt_lock);
 		kmem_free(kernel_map, (vm_offset_t)pldt->ldt_base,
 			pldt->ldt_len * sizeof(union descriptor));
 		FREE(pldt, M_SUBPROC);
+		mtx_lock_spin(&dt_lock);
 	}
 }
 
@@ -701,7 +703,7 @@
 		len = NLDT + 1;
 
 	/* Allocate a user ldt. */
-	if ((pldt = mdp->md_ldt) != NULL || len > pldt->ldt_len) {
+	if ((pldt = mdp->md_ldt) == NULL || len > pldt->ldt_len) {
 		struct proc_ldt *new_ldt;
 
 		new_ldt = user_ldt_alloc(mdp, len);
@@ -716,10 +718,13 @@
 				pldt->ldt_sd = new_ldt->ldt_sd;
 				pldt->ldt_base = new_ldt->ldt_base;
 				pldt->ldt_len = new_ldt->ldt_len;
+				mtx_unlock_spin(&dt_lock);
 				kmem_free(kernel_map, (vm_offset_t)old_ldt_base,
 					old_ldt_len * sizeof(union descriptor));
 				FREE(new_ldt, M_SUBPROC);
+				mtx_lock_spin(&dt_lock);
 			} else {
+				mtx_unlock_spin(&dt_lock);
 				/*
 				 * If other threads already did the work,
 				 * do nothing.
@@ -728,6 +733,7 @@
 				   (vm_offset_t)new_ldt->ldt_base,
 				   new_ldt->ldt_len * sizeof(union descriptor));
 				FREE(new_ldt, M_SUBPROC);
+				mtx_lock_spin(&dt_lock);
 				return (0);
 			}
 		} else
